// compile:   g++ -Wall    Classes-CPP.cpp -o Classes-CPP
// assembler: g++ -Wall -S Classes-CPP.cpp -o Classes-CPP.s
// symbols (as is):     nm    Classes-CPP
// symbols (demangled): nm -C Classes-CPP

// Questions
//  -Is there any runtime cost associated with this example?
//  -When is the constructor "Ring" and the destructor "~Ring()" called?
//  -What is the difference between "struct" and "class"?
//  -Why is "this" nessesary in the constructor "Ring(...)"?
//  -What would adding "explict" to the constructor declaration do?
//  -What is the "const" on "print()" for?
//  -What are "private", "protected", and "public" for?

#include <iostream>

struct Object {
  float x;

  Object(const float x) { this->x = x; }
  ~Object()             { }

  void print() const { std::cout << x << std::endl; }
};

int main() {
  Object x(2.1);

  x.print();

  return 0;
}
